## thrift 0.16.0

=== contrib/transport-sample/Makefile ===
THRIFT_DIR =../..
INCS_DIRS  =-I${THRIFT_DIR}/lib/cpp/src -I.
THRIFT_LIB =${THRIFT_DIR}/lib/cpp/.libs/libthrift.a
BOOST_LIB  =
CPP_DEFS   =
CPP_OPTS   =-Wall -O2

GEN_SRC    = gen-cpp/SampleService.cpp  \
             gen-cpp/Sample_types.cpp   \
             gen-cpp/SampleCallback.cpp \
             gen-cpp/Sample_constants.cpp
GEN_INC    = -Igen-cpp

default: server client
.PHONY: server client

server:
	g++ ${CPP_OPTS} ${CPP_DEFS} -o server/server ${GEN_INC} ${INCS_DIRS} server/server.cpp ${GEN_SRC} ${THRIFT_LIB} ${BOOST_LIB}

client:
	g++ ${CPP_OPTS} ${CPP_DEFS} -o client/client ${GEN_INC} ${INCS_DIRS} client/client.cpp ${GEN_SRC} ${THRIFT_LIB} ${BOOST_LIB}

clean:
	$(RM) -r client/client server/server

=== lib/java/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#

if(ANDROID)

    set(THRIFT_AAR outputs/aar/thrift-debug.aar outputs/aar/thrift-release.aar)
    add_custom_command(
        OUTPUT ${THRIFT_AAR}
        COMMAND ${GRADLE_EXECUTABLE}
            -p "${CMAKE_CURRENT_SOURCE_DIR}/android"
            "-PbuildDir=${CMAKE_CURRENT_BINARY_DIR}/android/build" assemble
    )
    add_custom_target(thrift_aar ALL DEPENDS ${THRIFT_AAR})

else()
    if(NOT JAVA_INSTALL_DIR)
        if(IS_ABSOLUTE "${LIB_INSTALL_DIR}")
            set(JAVA_INSTALL_DIR "${LIB_INSTALL_DIR}/java")
        else()
            set(JAVA_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/java")
        endif()
    endif()

    if(IS_ABSOLUTE "${DOC_INSTALL_DIR}")
        set(JAVA_DOC_INSTALL_DIR "${DOC_INSTALL_DIR}/java")
    else()
        set(JAVA_DOC_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${DOC_INSTALL_DIR}/java")
    endif()

    set(PRELEASE "true")
    if (CMAKE_BUILD_TYPE MATCHES DEBUG)
        set(PRELEASE "false")
    endif ()

    file(GLOB_RECURSE THRIFTJAVA_SOURCES LIST_DIRECTORIES false
        "${CMAKE_CURRENT_SOURCE_DIR}/src/*")
    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/build/libs/libthrift.jar"
        COMMENT "Building Java library using Gradle Wrapper"
        COMMAND ${GRADLEW_EXECUTABLE} ${GRADLE_OPTS} assemble
            --console=plain --no-daemon
            -Prelease=${PRELEASE}
            -Pthrift.version=${thrift_VERSION}
            "-Pbuild.dir=${CMAKE_CURRENT_BINARY_DIR}/build"
        DEPENDS ${THRIFTJAVA_SOURCES}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
    add_custom_target(ThriftJava ALL
        DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/build/libs/libthrift.jar")

    # Enable publishing from CMake if the publishing information is provided
    add_custom_target(MavenPublish
        COMMENT "Publishing Java Library to Apache Maven staging"
        DEPENDS ThriftJava
        COMMAND ${GRADLEW_EXECUTABLE} ${GRADLE_OPTS} clean uploadArchives
            --console=plain --no-daemon
            -Prelease=${PRELEASE}
            -Pthrift.version=${thrift_VERSION}
            "-Pbuild.dir=${CMAKE_CURRENT_BINARY_DIR}/build"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )

    # Hook the CMake install process to the results from make ALL.
    # This works best when 'make all && sudo make install/fast' is used.
    # Using slash to end the source location to avoid copying the directory path.
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build/libs/
            DESTINATION ${JAVA_INSTALL_DIR}
            FILES_MATCHING PATTERN "libthrift-${thrift_VERSION}.jar")
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build/deps/
            DESTINATION ${JAVA_INSTALL_DIR}
            FILES_MATCHING PATTERN "*.jar")
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build/docs/javadoc/
            DESTINATION ${JAVA_DOC_INSTALL_DIR})

    if(BUILD_TESTING)
        add_test(NAME JavaTest
            COMMAND ${GRADLEW_EXECUTABLE} ${GRADLE_OPTS} test
                --console=plain --no-daemon
                -Prelease=${PRELEASE}
                -Pthrift.version=${thrift_VERSION}
                "-Pbuild.dir=${CMAKE_CURRENT_BINARY_DIR}/build"
                "-Pthrift.compiler=${THRIFT_COMPILER}"
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    endif()

endif()

=== tutorial/cpp/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#

include(BoostMacros)
REQUIRE_BOOST_HEADERS()

#Make sure gen-cpp files can be included
include_directories("${CMAKE_CURRENT_BINARY_DIR}")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/gen-cpp")
include_directories("${PROJECT_SOURCE_DIR}/lib/cpp/src")

include(ThriftMacros)

set(tutorialgencpp_SOURCES
    gen-cpp/Calculator.cpp
    gen-cpp/SharedService.cpp
    gen-cpp/shared_types.cpp
    gen-cpp/tutorial_constants.cpp
    gen-cpp/tutorial_types.cpp
)
add_library(tutorialgencpp STATIC ${tutorialgencpp_SOURCES})
target_link_libraries(tutorialgencpp thrift)

add_custom_command(OUTPUT gen-cpp/Calculator.cpp gen-cpp/SharedService.cpp gen-cpp/shared_types.cpp gen-cpp/tutorial_constants.cpp gen-cpp/tutorial_types.cpp
    COMMAND ${THRIFT_COMPILER} --gen cpp -r ${PROJECT_SOURCE_DIR}/tutorial/tutorial.thrift
)

add_executable(TutorialServer CppServer.cpp)
target_link_libraries(TutorialServer tutorialgencpp)
target_link_libraries(TutorialServer thrift)
if (ZLIB_FOUND)
  target_link_libraries(TutorialServer ${ZLIB_LIBRARIES})
endif ()

add_executable(TutorialClient CppClient.cpp)
target_link_libraries(TutorialClient tutorialgencpp)
target_link_libraries(TutorialClient thrift)
if (ZLIB_FOUND)
  target_link_libraries(TutorialClient ${ZLIB_LIBRARIES})
endif ()

=== lib/cpp/test/qt/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#

set(CMAKE_AUTOMOC ON)
find_package(Qt5 REQUIRED COMPONENTS Test Network)
set(TQTcpServerTest_Qt5_SOURCES
    TQTcpServerTest.cpp
)
add_executable(TQTcpServerTest_Qt5 ${TQTcpServerTest_Qt5_SOURCES})
target_link_libraries(TQTcpServerTest_Qt5 testgencpp_cob)
target_link_libraries(TQTcpServerTest_Qt5 thriftqt5)
target_link_libraries(TQTcpServerTest_Qt5 thrift)
target_link_libraries(TQTcpServerTest_Qt5 Qt5::Test Qt5::Network)

add_test(NAME TQTcpServerTest_Qt5 COMMAND TQTcpServerTest_Qt5)

=== debian/changelog ===
thrift (0.16.0-2) experimental; urgency=medium

  * Run Go tests without non-portable race detector.
  * Disable tests that seem to be incompatible with newer GLib versions.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 01 Apr 2022 17:14:34 +0200

thrift (0.16.0-1) experimental; urgency=medium

  * New major upstream release (closes: #1008458):
    - fixes CVE-2020-13949: potential DoS when processing untrusted payloads
      (closes: #988949).
  * Rename related packages to -0.16.0 suffix.


 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 28 Mar 2022 01:34:46 +0200

=== debian/control ===
Source: thrift
Section: devel
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 11), dh-python,
 dh-golang, golang-golang-x-net-dev,
 gem2deb (>= 0.3.0~),
 bison, flex,
 libboost-all-dev (>= 1.61.0), libevent-dev, zlib1g-dev,
 libssl-dev,
 libglib2.0-dev,
 qtbase5-dev,
 python3-all-dev,
 python3-six,
 golang-go, golang-github-golang-mock-dev,
 pkg-php-tools (>= 1.14~), php-dev, phpunit, php-codesniffer,
 perl (>= 5.22), libbit-vector-perl, libclass-accessor-perl,
 libtest-exception-perl,
# openjdk-11-jdk, javahelper, maven-debian-helper (>= 1.5), ant (>= 1.7), ant-optional,
# libhttpclient-java, libslf4j-java, libservlet3.1-java (>= 8),
# nodejs, npm,
 ruby-dev (>= 1:2.2), ruby, bundler,
 rake,
 ruby-daemons, ruby-diff-lcs, ruby-eventmachine, ruby-rspec-core,
 ruby-rack, ruby-rack-test,
 ruby-rspec, ruby-rspec-expectations, ruby-rspec-mocks,
 thin,
# erlang-dev, erlang-eunit,
# liblua5.2-dev,
# google-mock
Build-Conflicts: rustc
Standards-Version: 4.6.0
Homepage: https://thrift.apache.org/
XS-Ruby-Versions: ruby2.7
XS-Go-Import-Path: github.com/apache/thrift/lib/go/thrift

Package: libthrift-0.16.0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Thrift C++ library
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization.  It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package contains the runtime libraries needed for C++ applications
 using Thrift.

Package: libthrift-dev
Architecture: any
Section: libdevel
Depends: libthrift-0.16.0 (= ${binary:Version}), ${misc:Depends}, pkg-config
Description: Thrift C++ library (development headers)
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization.  It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package contains the development libraries required for writing C++
 applications using Thrift.

Package: libthrift-c-glib0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Thrift glib library
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization.  It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package contains the glib based runtime libraries needed for C
 applications using Thrift.

Package: libthrift-c-glib-dev
Architecture: any
Section: libdevel
Depends: libthrift-c-glib0 (= ${binary:Version}), ${misc:Depends}, pkg-config
Description: Thrift glib library (development headers)
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization.  It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package contains the development libraries required for writing glib
 based C applications using Thrift.

Package: thrift-compiler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: thrift-compiler (<= 0.9.1-2)
Replaces: thrift-compiler (<= 0.9.1-2)
Description: code generator/compiler for Thrift definitions
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization.  It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package contains the compiler used to generate language code from
 Thrift definition files.

Package: python3-thrift
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Provides: ${python3:Provides}
Description: Python 3 library for Thrift
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization. It combines a software
 stack with a code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package provides the Python 3 bindings for Thrift.

#Package: libthrift-java
#Section: java
#Architecture: all
#Depends: ${java:Depends}, ${misc:Depends}
#Conflicts: libthrift-java (<= 0.9.1-2)
#Replaces: libthrift-java (<= 0.9.1-2)
#Description: Java language support for Thrift
# Thrift is a software framework for the development of reliable and
# performant communication and data serialization. It combines a software
# stack with code generation to build services that operate seamlessly
# across a number of different development languages.
# .
# This package provides the Java language support for Thrift.
#
#Package: libthrift-java-doc
#Architecture: all
#Section: doc
#Depends: ${misc:Depends}
#Suggests: libthrift-java
#Description: Java language support for Thrift - documentation
# Thrift is a software framework for the development of reliable and
# performant communication and data serialization. It combines a software
# stack with code generation to build services that operate seamlessly
# across a number of different development languages.
# .
# This package contains Javadoc HTML documentation for libthrift-java .
#
Package: php-thrift
Architecture: any
Section: php
Depends: ${phpcomposer:Debian-require}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${php:Provides}
Conflicts: php7.0-thrift, php7.2-thrift
Replaces: php7.0-thrift, php7.2-thrift
Description: PHP language support for Thrift
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization. It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package provides the PHP5 language support for Thrift.

Package: libthrift-perl
Section: perl
Architecture: all
Multi-Arch: foreign
Depends: ${perl:Depends}, ${misc:Depends}
Description: Perl language support for Thrift
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization. It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package provides the Perl language support for Thrift.

Package: golang-thrift-dev
Architecture: amd64 arm64 armel armhf i386 ppc64el
Multi-Arch: same
Depends: ${misc:Depends}
Description: Go language support for Thrift
 Thrift is a software framework for the development of reliable and
 performant communication and data serialization. It combines a software
 stack with code generation to build services that operate seamlessly
 across a number of different development languages.
 .
 This package provides the Go language support for Thrift.
#
#Package: ruby-thrift
#Section: libs
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Description: Ruby library for Thrift
# Thrift is a software framework for the development of reliable and
# performant communication and data serialization. It combines a software
# stack with a code generation to build services that operate seamlessly
# across a number of different development languages.
# .
# This package provides the Ruby bindings for Thrift.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# for Java install
#export CLASSPATH=/usr/share/java/commons-codec.jar:/usr/share/java/commons-logging.jar:/usr/share/java/slf4j-simple.jar:/usr/share/java/slf4j-api.jar:/usr/share/java/servlet-api-3.1.jar:/usr/share/java/httpcore.jar:/usr/share/java/httpclient.jar:/usr/share/java/junit4.jar:/usr/share/java/ant-junit.jar:.

export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

# Go 1.16 expects a go.mod file by default and thrift Go extension does not
# contain that, let's turn it off for now.
#export GO111MODULE=off

# for Go install
export DH_GOPKG=thrift
export XDG_CACHE_HOME=$(CURDIR)/go-cache/

# for Ruby install
export DESTDIR=$(CURDIR)/debian/tmp/

#export JAVA_PREFIX=/usr/share/java/
export PERL_PREFIX=/usr/
export INSTALLDIRS=vendor

export QT_SELECT=qt5

# Set install Perl locations
ARCHLIB := $(shell perl -MConfig -e 'print $$Config{vendorarch}')

RUBY_LIBDIR := $(shell ruby -rrbconfig -e'print RbConfig::CONFIG["vendordir"]')

PYTHON3_VERSIONS = $(shell py3versions -r)

override_dh_autoreconf:
	$(CURDIR)/bootstrap.sh

override_dh_auto_clean:
	$(RM) -r $(CURDIR)/go-cache/
	$(RM) $(CURDIR)/test/go/genmock.sh
	$(RM) -r $(CURDIR)/lib/py/build/ \
		$(CURDIR)/lib/py/thrift.egg-info/
	$(RM) $(CURDIR)/test/go/src/github.com \
		$(CURDIR)/test/go/src/golang.org/x/tools \
		$(CURDIR)/test/go/src/golang.org/x/net \
		$(CURDIR)/lib/go/test/gopath/src/golang.org/x/net \
		$(CURDIR)/lib/go/test/gopath/src/github.com/golang/mock
	[ ! -f Makefile ] || $(MAKE) clean
	cd $(CURDIR)/lib/php/src/ext/thrift_protocol/ && phpize --clean
	find $(CURDIR) \( -name Makefile -o -name Makefile.in \) -exec rm {} \;
	find $(CURDIR) -name .dirstamp -exec rm {} \;
	$(RM) aclocal/libtool.m4 aclocal/lt*
	$(RM) aclocal.m4 config.guess config.h config.log config.status \
		config.sub configure configure.scan depcomp libtool stamp-h1 \
		lib/cpp/*.pc lib/c_glib/thrift_c_glib.pc
	$(RM) lib/c_glib/src/thrift/config.h \
		lib/c_glib/src/thrift/stamp-h3 \
		lib/cpp/src/thrift/config.h \
		lib/cpp/src/thrift/stamp-h2 \
		lib/cpp/test/tests.xml
	$(RM) autoscan.log config.hin
#	jh_clean
	# let dh clean
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-cpp --with-c_glib --with-php --with-php_extension \
		--with-perl --without-python --with-py3 --without-java \
		--without-nodejs --without-erlang --without-lua \
		--with-go --with-ruby \
		--with-qt4=no --with-qt5=yes \
		--without-rust \
		--disable-tutorial

override_dh_auto_build:
#	mkdir -p $(CURDIR)/lib/java/build/lib/
	# symlinks for Go build
	mkdir -p $(CURDIR)/lib/go/test/gopath/src/
	ln -s /usr/share/gocode/src/github.com \
		$(CURDIR)/test/go/src/
	mkdir -p $(CURDIR)/lib/go/test/gopath/src/golang.org/x/
	ln -s /usr/share/gocode/src/golang.org/x/net \
		$(CURDIR)/lib/go/test/gopath/src/golang.org/x/

	dh_auto_build --no-parallel
	set -ex; cd lib/py && for python in $(PYTHON3_VERSIONS); do \
	  $$python setup.py build; \
	done
#	jh_build thrift.jar $(CURDIR)/lib/java/src/

override_dh_auto_install:
	dh_auto_install -- INSTALLDIRS=vendor
	set -ex; cd lib/py && for python in $(PYTHON3_VERSIONS); do \
	  $$python setup.py install --install-layout=deb --root=$(CURDIR)/debian/tmp; \
	done
#	jh_installlibs -plibthrift-java thrift.jar
#	jh_installjavadoc
#	jh_depends

	find $(CURDIR)/debian/tmp/ -name \*.la -exec rm {} \;

override_dh_missing:
	dh_missing --list-missing

override_dh_auto_test:
	cd $(CURDIR)/lib/c_glib/test/ && \
		$(MAKE) gen-c_glib/t_test_enum_test_types.h
	mkdir -p $(CURDIR)/vendor/bin/
	ln -s /usr/bin/phpunit $(CURDIR)/vendor/bin/
	ln -s $(CURDIR)/lib/php/src/autoload.php $(CURDIR)/vendor/
	touch $(CURDIR)/test/go/genmock.sh
	mkdir -p $(CURDIR)/test/go/src/golang.org/x/
	# symlinks for Go testing
	ln -s /usr/share/gocode/src/golang.org/x/tools \
		$(CURDIR)/test/go/src/golang.org/x/
	ln -s /usr/share/gocode/src/golang.org/x/net/ \
		$(CURDIR)/test/go/src/golang.org/x/
	# GOPATH set automatically to $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
	mkdir -p $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/src/github.com/apache/thrift/lib/
	ln -s $(CURDIR)/lib/go \
		$(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/src/github.com/apache/thrift/lib/
	mkdir -p $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/src/github.com/golang/
	ln -s /usr/share/gocode/src/github.com/golang/mock \
		$(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/src/github.com/golang/
	ln -s $(CURDIR)/lib/go/test/fuzz/gen-go/shared \
		$(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/src/
	ln -s $(CURDIR)/lib/go/test/fuzz/gen-go/tutorial \
		$(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/src/
	ln -s $(CURDIR)/test \
		$(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)/src/github.com/apache/thrift/
	dh_auto_test --no-parallel

%:
	dh $@ --with python3,ruby,phpcomposer

.PHONY: override_dh_autoreconf override_dh_auto_clean \
	override_dh_auto_configure override_dh_auto_install \
	override_dh_missing override_dh_auto_test

=== debian/watch ===
version=3
https://thrift.apache.org/download .*/thrift-(\d[\d\.]+)\.(?:tgz|tar\.(?:gz|bz2|xz))

## thrift 0.17.0

=== CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#

cmake_minimum_required(VERSION 3.4)

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)  # package version behavior added in cmake 3.0
endif()
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)  # find_package behavior added in cmake 3.12
endif()

# PACKAGE_VERSION is used by cpack scripts currently
# Both thrift_VERSION and PACKAGE_VERSION should be the same for now
set(thrift_VERSION "0.17.0")
set(PACKAGE_VERSION ${thrift_VERSION})

project("thrift" VERSION ${PACKAGE_VERSION})
message(STATUS "Configuring ${CMAKE_PROJECT_NAME} ${thrift_VERSION}")


set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/build/cmake")

# Some default settings
include(DefineCMakeDefaults)

# Build time options are defined here
include(DefineOptions)
include(DefineInstallationPaths)

# Based on the options set some platform specifics
include(DefinePlatformSpecifc)

# Add CMake targets for static code analysis
include(StaticCodeAnalysis)

# Generate the config.h file
include(ConfigureChecks)

# Generate the ThriftConfig.cmake module
include(GenerateConfigModule)

# Packaging
include(CPackConfig)

# Dependencies
include(BoostMacros)
find_package(Threads)
include(CTest)

if(BUILD_TESTING)
  message(STATUS "Building with unittests")

  enable_testing()
  # Define "make check" as alias for "make test"
  add_custom_target(check COMMAND ctest)
else ()
  message(STATUS "Building without tests")
endif ()

if(BUILD_COMPILER)
    if(NOT EXISTS ${THRIFT_COMPILER})
        set(THRIFT_COMPILER $<TARGET_FILE:thrift-compiler>)
    endif()
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/compiler/cpp)
elseif(EXISTS ${THRIFT_COMPILER})
    add_executable(thrift-compiler IMPORTED)
    set_property(TARGET thrift-compiler PROPERTY IMPORTED_LOCATION ${THRIFT_COMPILER})
endif()

if(BUILD_CPP)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/cpp)
    if(BUILD_TUTORIALS)
        add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/tutorial/cpp)
    endif()
    if(BUILD_TESTING)
        if(WITH_LIBEVENT AND WITH_ZLIB AND WITH_OPENSSL)
            add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/test/cpp)
        else()
            message(WARNING "libevent and/or ZLIB and/or OpenSSL not found or disabled; will not build some tests")
        endif()
    endif()
endif()

if(BUILD_C_GLIB)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/c_glib)
    if(BUILD_TESTING)
        add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/test/c_glib)
    endif()
endif()

if(BUILD_JAVA)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/java)
endif()

if(BUILD_JAVASCRIPT)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/js)
endif()

if(BUILD_KOTLIN)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/kotlin)
endif()

if(BUILD_NODEJS)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/nodejs)
endif()

if(BUILD_PYTHON)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/py)
    if(BUILD_TESTING)
        add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/test/py)
    endif()
endif()

# Create the uninstall target
add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${PROJECT_SOURCE_DIR}/build/cmake/uninstall.cmake")

PRINT_CONFIG_SUMMARY()

=== compiler/cpp/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#

cmake_minimum_required(VERSION 3.3)
project("thrift-compiler" VERSION ${PACKAGE_VERSION})

# version.h now handled via veralign.sh
#configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/thrift/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/thrift/version.h)

find_package(FLEX REQUIRED)
find_package(BISON REQUIRED)

# create directory for thrifty and thriftl
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/thrift/)

# Create flex and bison files and build the lib parse static library
BISON_TARGET(thrifty ${CMAKE_CURRENT_SOURCE_DIR}/src/thrift/thrifty.yy ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.cc)
FLEX_TARGET(thriftl ${CMAKE_CURRENT_SOURCE_DIR}/src/thrift/thriftl.ll ${CMAKE_CURRENT_BINARY_DIR}/thrift/thriftl.cc)
ADD_FLEX_BISON_DEPENDENCY(thriftl thrifty)

set(parse_SOURCES
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.cc
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thriftl.cc
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.hh
)

add_library(parse STATIC ${parse_SOURCES})

# Create the thrift compiler
set(compiler_core
    src/thrift/common.cc
    src/thrift/generate/t_generator.cc
    src/thrift/parse/t_typedef.cc
    src/thrift/parse/parse.cc
    src/thrift/version.h
)

set(thrift-compiler_SOURCES
    src/thrift/main.cc
    src/thrift/audit/t_audit.cpp
)

set(thrift_compiler_LANGS
)

# This macro adds an option THRIFT_COMPILER_${NAME}
# that allows enabling or disabling certain languages
macro(THRIFT_ADD_COMPILER name description initial)
    string(TOUPPER "THRIFT_COMPILER_${name}" enabler)
    set(src "src/thrift/generate/t_${name}_generator.cc")
    option(${enabler} ${description} ${initial})
    if(${enabler})
        list(APPEND thrift-compiler_SOURCES ${src})
        list(APPEND thrift_compiler_LANGS ${name})
    endif()
endmacro()

# The following compiler can be enabled or disabled
THRIFT_ADD_COMPILER(c_glib  "Enable compiler for C with Glib" ON)
THRIFT_ADD_COMPILER(cpp     "Enable compiler for C++" ON)
THRIFT_ADD_COMPILER(d       "Enable compiler for D" ON)
THRIFT_ADD_COMPILER(dart    "Enable compiler for Dart" ON)
THRIFT_ADD_COMPILER(delphi  "Enable compiler for Delphi" ON)
THRIFT_ADD_COMPILER(erl     "Enable compiler for Erlang" ON)
THRIFT_ADD_COMPILER(go      "Enable compiler for Go" ON)
THRIFT_ADD_COMPILER(gv      "Enable compiler for GraphViz" ON)
THRIFT_ADD_COMPILER(haxe    "Enable compiler for Haxe" ON)
THRIFT_ADD_COMPILER(html    "Enable compiler for HTML Documentation" ON)
THRIFT_ADD_COMPILER(markdown "Enable compiler for Markdown Documentation" ON)
THRIFT_ADD_COMPILER(java    "Enable compiler for Java"   ON)
THRIFT_ADD_COMPILER(javame  "Enable compiler for Java ME" ON)
THRIFT_ADD_COMPILER(js      "Enable compiler for JavaScript" ON)
THRIFT_ADD_COMPILER(json    "Enable compiler for JSON" ON)
THRIFT_ADD_COMPILER(kotlin  "Enable compiler for Kotlin" ON)
THRIFT_ADD_COMPILER(lua     "Enable compiler for Lua" ON)
THRIFT_ADD_COMPILER(netstd  "Enable compiler for .NET Standard" ON)
THRIFT_ADD_COMPILER(ocaml   "Enable compiler for OCaml" ON)
THRIFT_ADD_COMPILER(perl    "Enable compiler for Perl" ON)
THRIFT_ADD_COMPILER(php     "Enable compiler for PHP" ON)
THRIFT_ADD_COMPILER(py      "Enable compiler for Python 2.0" ON)
THRIFT_ADD_COMPILER(rb      "Enable compiler for Ruby" ON)
THRIFT_ADD_COMPILER(rs      "Enable compiler for Rust" ON)
THRIFT_ADD_COMPILER(st      "Enable compiler for Smalltalk" ON)
THRIFT_ADD_COMPILER(swift   "Enable compiler for Cocoa Swift" ON)
THRIFT_ADD_COMPILER(xml     "Enable compiler for XML" ON)
THRIFT_ADD_COMPILER(xsd     "Enable compiler for XSD" ON)

# Thrift is looking for include files in the src directory
# we also add the current binary directory for generated files
include_directories(${CMAKE_CURRENT_BINARY_DIR} src)

list(APPEND thrift-compiler_SOURCES ${compiler_core})

add_executable(thrift-compiler ${thrift-compiler_SOURCES})

set_target_properties(thrift-compiler PROPERTIES RUNTIME_OUTPUT_DIRECTORY bin/)
set_target_properties(thrift-compiler PROPERTIES OUTPUT_NAME thrift)

target_link_libraries(thrift-compiler parse)

add_custom_command(OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/thrift${CMAKE_EXECUTABLE_SUFFIX}"
    DEPENDS thrift-compiler
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:thrift-compiler>" "${CMAKE_CURRENT_SOURCE_DIR}/"
    COMMENT "Copying the thrift compiler to the source tree for use by downstream targets")
add_custom_target(copy-thrift-compiler
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/thrift${CMAKE_EXECUTABLE_SUFFIX}")

install(TARGETS thrift-compiler DESTINATION bin)

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== test/c_glib/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#

# Contains the thrift specific target_link_libraries
include(ThriftMacros)

find_package(GLIB REQUIRED COMPONENTS gobject)
include_directories(SYSTEM "${GLIB_INCLUDE_DIR}")
include_directories(SYSTEM "${GLIBCONFIG_INCLUDE_DIR}")

#Make sure gen-c_glib files can be included
include_directories("${CMAKE_CURRENT_BINARY_DIR}")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/gen-c_glib")
include_directories("${PROJECT_SOURCE_DIR}/lib/c_glib/src")
include_directories(SYSTEM "${OPENSSL_INCLUDE_DIR}")

set(crosstestgencglib_SOURCES
	gen-c_glib/t_test_second_service.c
	gen-c_glib/t_test_second_service.h
	gen-c_glib/t_test_thrift_test.c
	gen-c_glib/t_test_thrift_test.h
	gen-c_glib/t_test_thrift_test_types.c
	gen-c_glib/t_test_thrift_test_types.h
)
add_library(crosstestgencglib STATIC ${crosstestgencglib_SOURCES})
target_link_libraries(crosstestgencglib thrift_c_glib)

if (WITH_ZLIB)
  target_link_libraries(crosstestgencglib thrift_c_glib_zlib)
endif ()

add_executable(test_server src/test_server.c src/thrift_test_handler.c src/thrift_second_service_handler.c)
target_link_libraries(test_server crosstestgencglib ${ZLIB_LIBRARIES})

add_executable(test_client src/test_client.c)
target_link_libraries(test_client crosstestgencglib "${OPENSSL_LIBRARIES}")

#
# Common thrift code generation rules
#

add_custom_command(OUTPUT gen-c_glib/t_test_second_service.c  gen-c_glib/t_test_second_service.h  gen-c_glib/t_test_thrift_test.c  gen-c_glib/t_test_thrift_test.h  gen-c_glib/t_test_thrift_test_types.c  gen-c_glib/t_test_thrift_test_types.h
    COMMAND ${THRIFT_COMPILER} --gen c_glib -r ${PROJECT_SOURCE_DIR}/test/ThriftTest.thrift
)

=== compiler/cpp/tests/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#
cmake_minimum_required(VERSION 2.8.12)

project(thrift_compiler_tests)

set(THRIFT_COMPILER_SOURCE_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/..
)

# don't generate ZERO_CHECK
set(CMAKE_SUPPRESS_REGENERATION true)

# version.h now handled via veralign.sh
#configure_file(${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/thrift/version.h)
if(MSVC)
    # The winflexbison generator outputs some macros that conflict with the Visual Studio 2010 copy of stdint.h
    # This might be fixed in later versions of Visual Studio, but an easy solution is to include stdint.h first
    if(HAVE_STDINT_H)
        add_definitions(-D__STDC_LIMIT_MACROS)
        add_definitions(/FI"stdint.h")
    endif(HAVE_STDINT_H)
endif()

find_package(FLEX REQUIRED)
find_package(BISON REQUIRED)

# create directory for thrifty and thriftl
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/thrift/)

# Create flex and bison files and build the lib parse static library
BISON_TARGET(thrifty ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/thrifty.yy ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.cc)
FLEX_TARGET(thriftl ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/thriftl.ll ${CMAKE_CURRENT_BINARY_DIR}/thrift/thriftl.cc)
ADD_FLEX_BISON_DEPENDENCY(thriftl thrifty)

set(parse_SOURCES
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.cc
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thriftl.cc
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.hh
)

add_library(parse STATIC ${parse_SOURCES})

# Thrift compiler tests
set(thrift_compiler_tests
)

# you can add some files manually there 
set(thrift_compiler_tests_manual_SOURCES
    # tests file to avoid main in every test file
    ${CMAKE_CURRENT_SOURCE_DIR}/tests_main.cc
)

# set variable for tests sources - will be filled later
set(thrift_compiler_tests_SOURCES
)

set(thrift_compiler_SOURCES
    ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/logging.cc # we use logging instead of main to avoid breaking compillation (2 main v)
    ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/audit/t_audit.cpp
    ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/common.cc
    ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/generate/t_generator.cc
    ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/parse/t_typedef.cc
    ${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/parse/parse.cc
    ${THRIFT_COMPILER_SOURCE_DIR}/thrift/version.h
)

# This macro adds an option THRIFT_COMPILER_${NAME}
# that allows enabling or disabling certain languages
macro(THRIFT_ADD_COMPILER name description initial)
    string(TOUPPER "THRIFT_COMPILER_${name}" enabler)
    set(src "${THRIFT_COMPILER_SOURCE_DIR}/src/thrift/generate/t_${name}_generator.cc")
    option(${enabler} ${description} ${initial})
    if(${enabler})
        list(APPEND thrift_compiler_SOURCES ${src})
        file(GLOB thrift_compiler_tests_SOURCES
            "${CMAKE_CURRENT_SOURCE_DIR}/${name}/*.c*"
            "${CMAKE_CURRENT_SOURCE_DIR}/${name}/*.thrift"
        )
    endif()
endmacro()

# The following compiler with unit tests can be enabled or disabled
THRIFT_ADD_COMPILER(c_glib  "Enable compiler for C with Glib" OFF)
THRIFT_ADD_COMPILER(cpp     "Enable compiler for C++" OFF)
THRIFT_ADD_COMPILER(d       "Enable compiler for D" OFF)
THRIFT_ADD_COMPILER(dart    "Enable compiler for Dart" OFF)
THRIFT_ADD_COMPILER(delphi  "Enable compiler for Delphi" OFF)
THRIFT_ADD_COMPILER(erl     "Enable compiler for Erlang" OFF)
THRIFT_ADD_COMPILER(go      "Enable compiler for Go" OFF)
THRIFT_ADD_COMPILER(gv      "Enable compiler for GraphViz" OFF)
THRIFT_ADD_COMPILER(haxe    "Enable compiler for Haxe" OFF)
THRIFT_ADD_COMPILER(html    "Enable compiler for HTML Documentation" OFF)
THRIFT_ADD_COMPILER(java    "Enable compiler for Java"   OFF)
THRIFT_ADD_COMPILER(javame  "Enable compiler for Java ME" OFF)
THRIFT_ADD_COMPILER(js      "Enable compiler for JavaScript" OFF)
THRIFT_ADD_COMPILER(json    "Enable compiler for JSON" OFF)
THRIFT_ADD_COMPILER(lua     "Enable compiler for Lua" OFF)
THRIFT_ADD_COMPILER(netstd  "Enable compiler for .NET Standard" ON)
THRIFT_ADD_COMPILER(ocaml   "Enable compiler for OCaml" OFF)
THRIFT_ADD_COMPILER(perl    "Enable compiler for Perl" OFF)
THRIFT_ADD_COMPILER(php     "Enable compiler for PHP" OFF)
THRIFT_ADD_COMPILER(py      "Enable compiler for Python 2.0" OFF)
THRIFT_ADD_COMPILER(rb      "Enable compiler for Ruby" OFF)
THRIFT_ADD_COMPILER(rs      "Enable compiler for Rust" OFF)
THRIFT_ADD_COMPILER(st      "Enable compiler for Smalltalk" OFF)
THRIFT_ADD_COMPILER(swift   "Enable compiler for Swift" OFF)
THRIFT_ADD_COMPILER(xml     "Enable compiler for XML" OFF)
THRIFT_ADD_COMPILER(xsd     "Enable compiler for XSD" OFF)

# Thrift is looking for include files in the src directory
# we also add the current binary directory for generated files
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${THRIFT_COMPILER_SOURCE_DIR}/src ${CMAKE_CURRENT_SOURCE_DIR}/catch)

add_library(thrift_compiler ${thrift_compiler_SOURCES})

#link parse lib to thrift_compiler lib
target_link_libraries(thrift_compiler parse)

# add tests executable
add_executable(thrift_compiler_tests ${thrift_compiler_tests_manual_SOURCES} ${thrift_compiler_tests_SOURCES})

# if generates for Visual Studio set thrift_compiler_tests as default project
if(MSVC)
    set_property(TARGET thrift_compiler_tests PROPERTY VS_STARTUP_PROJECT thrift_compiler_tests)
endif()

set_target_properties(thrift_compiler_tests PROPERTIES RUNTIME_OUTPUT_DIRECTORY bin/)
set_target_properties(thrift_compiler_tests PROPERTIES OUTPUT_NAME thrift_compiler_tests)

target_link_libraries(thrift_compiler_tests thrift_compiler)

enable_testing()
add_test(NAME ThriftTests COMMAND thrift_compiler_tests)

=== debian/changelog ===
thrift (0.17.0-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 28 Sep 2022 19:05:02 +0200

thrift (0.17.0-1) experimental; urgency=medium

  * New major upstream release.
  * Rename related packages to -0.17.0 suffix.
  * Update debhelper level to 13 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 22 Sep 2022 22:21:38 +0200

thrift (0.16.0-7) unstable; urgency=medium

  * Don't remove generated config.h files (closes: #1019182).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 13 Sep 2022 20:24:02 +0200

thrift (0.16.0-6) unstable; urgency=medium

  * Replace outdated TLS test keys (closes: #1010120, #1015049).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 28 Aug 2022 12:41:21 +0200

thrift (0.16.0-5) unstable; urgency=medium

  * Disable IPv4 tests for not working on IPv6 only hosts (closes: #1011011).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 15 May 2022 14:42:11 +0200

thrift (0.16.0-4) unstable; urgency=medium

  * Specify libs as section for libthrift-0.16.0 .
  * Backport upstream fix for out of memory when use TNonblockingServer.
  * Backport upstream fix THRIFT-5449: use poll instead of select in Python
    TNonblockingServer if available.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 26 Apr 2022 17:14:22 +0200

thrift (0.16.0-3) unstable; urgency=medium

  * Upload to Sid.
  * This release contains fix for Python 3.10 (closes: #1008810).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 19 Apr 2022 17:08:21 +0200

=== debian/control ===
--- 
+++ 
@@ -2,39 +2,35 @@
 Section: devel
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 11), dh-python,
+Build-Depends: debhelper-compat (= 13), dh-python,
  dh-golang, golang-golang-x-net-dev,
- gem2deb (>= 0.3.0~),
+ gem2deb,
  bison, flex,
- libboost-all-dev (>= 1.61.0), libevent-dev, zlib1g-dev,
+ libboost-all-dev, libevent-dev, zlib1g-dev,
  libssl-dev,
  libglib2.0-dev,
  qtbase5-dev,
- python3-all-dev,
- python3-six,
+ python3-all-dev, python3-six,
  golang-go, golang-github-golang-mock-dev,
  pkg-php-tools (>= 1.14~), php-dev, phpunit, php-codesniffer,
- perl (>= 5.22), libbit-vector-perl, libclass-accessor-perl,
- libtest-exception-perl,
+ perl, libbit-vector-perl, libclass-accessor-perl, libtest-exception-perl,
 # openjdk-11-jdk, javahelper, maven-debian-helper (>= 1.5), ant (>= 1.7), ant-optional,
 # libhttpclient-java, libslf4j-java, libservlet3.1-java (>= 8),
 # nodejs, npm,
- ruby-dev (>= 1:2.2), ruby, bundler,
- rake,
+ ruby-dev, ruby, bundler, rake,
  ruby-daemons, ruby-diff-lcs, ruby-eventmachine, ruby-rspec-core,
- ruby-rack, ruby-rack-test,
- ruby-rspec, ruby-rspec-expectations, ruby-rspec-mocks,
- thin,
+ ruby-rack, ruby-rack-test, ruby-rspec, ruby-rspec-expectations,
+ ruby-rspec-mocks, thin,
 # erlang-dev, erlang-eunit,
 # liblua5.2-dev,
 # google-mock
 Build-Conflicts: rustc
 Standards-Version: 4.6.0
 Homepage: https://thrift.apache.org/
-XS-Ruby-Versions: ruby2.7
 XS-Go-Import-Path: github.com/apache/thrift/lib/go/thrift
 
-Package: libthrift-0.16.0
+Package: libthrift-0.17.0
+Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -48,9 +44,10 @@
  using Thrift.
 
 Package: libthrift-dev
+Section: libdevel
 Architecture: any
-Section: libdevel
-Depends: libthrift-0.16.0 (= ${binary:Version}), ${misc:Depends}, pkg-config
+Multi-Arch: same
+Depends: libthrift-0.17.0 (= ${binary:Version}), ${misc:Depends}, pkg-config
 Description: Thrift C++ library (development headers)
  Thrift is a software framework for the development of reliable and
  performant communication and data serialization.  It combines a software
@@ -75,8 +72,9 @@
  applications using Thrift.
 
 Package: libthrift-c-glib-dev
+Section: libdevel
 Architecture: any
-Section: libdevel
+Multi-Arch: same
 Depends: libthrift-c-glib0 (= ${binary:Version}), ${misc:Depends}, pkg-config
 Description: Thrift glib library (development headers)
  Thrift is a software framework for the development of reliable and
@@ -142,8 +140,8 @@
 # This package contains Javadoc HTML documentation for libthrift-java .
 #
 Package: php-thrift
+Section: php
 Architecture: any
-Section: php
 Depends: ${phpcomposer:Debian-require}, ${shlibs:Depends}, ${misc:Depends}
 Provides: ${php:Provides}
 Conflicts: php7.0-thrift, php7.2-thrift
@@ -154,7 +152,7 @@
  stack with code generation to build services that operate seamlessly
  across a number of different development languages.
  .
- This package provides the PHP5 language support for Thrift.
+ This package provides the PHP language support for Thrift.
 
 Package: libthrift-perl
 Section: perl

=== debian/rules ===
--- 
+++ 
@@ -77,7 +77,7 @@
 		--without-nodejs --without-erlang --without-lua \
 		--with-go --with-ruby \
 		--with-qt4=no --with-qt5=yes \
-		--without-rust \
+		--without-rust --without-kotlin \
 		--disable-tutorial
 
 override_dh_auto_build:
